<template>
	<div class="network-recap row-padding col-padding pink-gradient lightestpink-color">
		<h3 class="hustle medium">Network</h3>
			
		<div class="container">
			<div class="nodes flex row-padding">
				<div v-for="node in sorted_nodes" class="node-wrapper" :class="[inactive(node) ? 'darkestpink-bkg' : 'lightestpink-bkg']" v-on:click="$emit('gotonode', node.id)">
					<div class="node" :class="{ inactive : inactive(node), special : node.type != 'builder'}">
						<div class="inner">
							<div v-if="node.type == 'builder'" class="favicon":style="{backgroundImage : nodeFavicon(node.data.host)}"></div>
							
							<div v-else class="circle">
								<svg v-if="node.type == 'keygen'" xmlns="http://www.w3.org/2000/svg" width="24.2" height="36.306" viewBox="0 0 24.2 36.306">
									<g transform="translate(-278.062 -262.548)">
										<path d="M281.52,274.65v-12.1h17.288v12.1h3.454v19.019a5.187,5.187,0,0,1-5.187,5.187H283.249a5.187,5.187,0,0,1-5.187-5.187h0V274.65Zm3.458-8.644H295.35v8.644H284.977Zm13.831,12.1H281.52v15.56a1.728,1.728,0,0,0,1.726,1.732h13.833a1.729,1.729,0,0,0,1.729-1.729h0Z" fill="#feb3ff" fill-rule="evenodd"/>
									</g>
								</svg>

								<svg v-if="node.type == 'decrypter'" xmlns="http://www.w3.org/2000/svg" width="28.306" height="36.306" viewBox="0 0 28.306 36.306">
									<path d="M331.357,262.548,317.2,280.7l14.153,18.153L345.51,280.7Zm1.491,8.418,7.59,9.735-6.41,8.221-1.18,1.514Zm-3,.024v19.423l-7.572-9.712Z" transform="translate(-317.204 -262.548)" fill="#feb3ff"/>
								</svg>
								
								<svg v-if="node.type == 'incubator'" xmlns="http://www.w3.org/2000/svg" width="23.72" height="38.954" viewBox="0 0 23.72 38.954">
									<path d="M378.8,281.963l-9.094-9.1,7.617-7.617-2.828-2.828-7.618,7.617-7.491-7.491-2.828,2.828,7.491,7.491-8.969,8.969,9.1,9.094-7.617,7.618,2.828,2.828L367,293.76l7.492,7.491,2.828-2.828-7.491-7.492Zm-18.063-.126,1.124-1.124h10.032l1.25,1.25-1.75,1.75h-8.78Zm6.14-6.14,3.016,3.016h-6.032Zm-2.264,10.016h4.78L367,288.1Z" transform="translate(-355.081 -262.423)" fill="#feb3ff"/>
								</svg>
								
								<svg v-if="node.type == 'compiler'" xmlns="http://www.w3.org/2000/svg" width="37" height="37" viewBox="0 0 37 37">
									<path d="M3533.969-172v-4.031h-3.937V-172H3526v-4.031h-4.031a3.779,3.779,0,0,1-2.769-1.169,3.778,3.778,0,0,1-1.172-2.766V-184H3514v-4.031h4.031v-3.938H3514V-196h4.031v-4.031a3.779,3.779,0,0,1,1.169-2.768,3.786,3.786,0,0,1,2.769-1.169H3526V-208h4.031v4.031h3.938V-208H3538v4.031h4.031a3.787,3.787,0,0,1,2.769,1.169,3.784,3.784,0,0,1,1.172,2.766V-196H3550v4.031h-4.031v3.938H3550V-184h-4.031v4.03a4,4,0,0,1-3.937,3.938H3538V-172Zm-12-7.968h20.063v-20.064h-20.062ZM3526.3-183v-14h8.781l2,2v3.919l-.8.82,1.421,1.439v3.661l-2.16,2.16Zm2.661-2.281h5.2l.859-.859v-1.96l-.859-.859h-5.2Zm0-5.859h4.719l.72-.721v-2.159l-.7-.7h-4.739Z" transform="translate(-3513.5 208.5)" fill="#feb3ff" stroke="rgba(0,0,0,0)" stroke-miterlimit="10" stroke-width="1"/>
								</svg>
							</div>
						</div>
					</div>
					
					<div class="process align-center">
						<span v-if="!inactive(node)">{{parseTime(node.processes[0].end*1000 - current_time)}}</span>
						<span class="uppercase bold" v-else>{{getLocale('inactive')}}</span>
					</div>
				</div>
			</div>
		</div>
	</div>
</template>


<script>
	var browser = browser || chrome;
	import Vue from 'vue';
	import { commonMixin } from '../mixins/common.js';
	import { storeGettersMixin } from '../mixins/store_getters.js';
	
	export default {
		computed: {
			sorted_nodes(){
				let sorted_nodes = [];
				
				this.grid_nodes.forEach(function(node){
					if(node.data != null){
						node.processes = this.nodeProcesses(node);
						sorted_nodes.push(node);
					}
				}.bind(this));
				
				sorted_nodes.sort(function(a,b){
					if(this.inactive(b) && this.inactive(a) && b.type != 'builder') return 1
					if(this.inactive(b) && this.inactive(a) && a.type != 'builder') return -1
					if(this.inactive(b)) return 1
					if(this.inactive(a)) return -1
					return (a.processes[0].end > b.processes[0].end) ? 1 : -1;
				}.bind(this));
				
				return sorted_nodes;
			}
		},
		methods: {
			nodeProcesses(node){
				if(node.data.assignment == null) return [];
				let processes = this.processes.filter(function(p){
					return p.vairus_id == node.data.assignment;
				}.bind(this));
				
				processes.sort(function(a,b){
					return (a.end > b.end) ? 1 : -1;
				});
				
				return processes;
			},
			inactive(node){
				var max_processes = 1;
				if(node.data.level >= 20) max_processes = 3;
				if(node.data.level >= 10) max_processes = 2;
				
				if(node.type != 'builder' && node.processes.length == 0) return true;
				if(node.type == 'builder' && node.processes.length < max_processes) return true;
			},
			parseTime(timestamp){
				if(timestamp < 0) timestamp = 0;
			
				let d = Math.floor((timestamp / (1000 * 60 * 60 * 24)));
				timestamp -=  d*(1000 * 60 * 60 * 24);
				let h = Math.floor((timestamp / (1000 * 60 * 60)));
				let m = Math.floor((timestamp / (1000 * 60)) % 60);
				let s = Math.floor((timestamp / 1000) % 60);
				
				if(d > 0){
					return  d+'D '+h.toString().padStart(2, '0')+'H';
				}
				if(h > 0){
					return  h.toString().padStart(2, '0')+'H '+m.toString().padStart(2, '0')+'M';
				}
				
				return m.toString().padStart(2, '0')+'M '+s.toString().padStart(2, '0')+'S';
			},
		},
		mixins: [commonMixin, storeGettersMixin],
		components: { }
	}
	
</script>


<style lang="scss" scoped>
	@import "../styles/variables";

	.network-recap{
		border-radius: 10px;
		
		hr{
			margin: 10px 0;
		}
	
		.container{
		
			.nodes{
				flex-wrap: nowrap;
				overflow-x: auto;
				
				scrollbar-width: thin;
				scrollbar-color: $darkestpink $black;
				
				&::-webkit-scrollbar {
					width: 8px;
				}
				&::-webkit-scrollbar-track {
					background-color: $black;
				}
				&::-webkit-scrollbar-thumb {
					background-color: $darkestpink;
				}
				
				.node-wrapper{
					border-radius: 10px;
					margin-right: 15px;
					cursor: pointer;
				
					.node{
						position: relative;
						width: 50px;
						height: 50px;
						background: radial-gradient(ellipse at center, #120E18 0%, #853D85 100%);
						border-radius: 5px;
						transform: rotate(45deg);
						margin: 20px;
						
						&.inactive{
							background: black;
						}
						
						&.special{
							border-radius: 50%;
						}
						
						.inner{
							padding-top: 100%;
						
							.favicon,
							.circle{
								position: absolute;
								left: 25%;
								top: 25%;
								width: 50%;
								height: 50%;
								background-size: contain;
								transform: rotate(-45deg);
							}
							
							.circle{
								background-color: black;
								border-radius: 50%;
								
								svg{
									position: absolute;
									left: 0%;
									top: 0%;
									width: 100%;
									height: 100%;
								}
							}
						}
					}
				}
				
				.process{
					padding: 10px 0;
					background-color: $darkestpink;
					border-bottom-left-radius: 9px;
					border-bottom-right-radius: 9px;
				}
			}
		}
	}
</style>
